/***************************************************************************/
/*EXPCARD.C    Reads records from Windows cardfile, exports as ASCII text  */
/*             file.  BETA version.                                        */
/*                                                                         */
/*             Command Line Usage:                                         */
/*             EXPCARD cardfile exportfile                                 */
/*                                                                         */
/*PROGRAMMER:  Fred Jacobs 08/26/91                                        */
/***************************************************************************/

#include <stdio.h>
#include <conio.h>
#include <string.h>

main(int argc,char *argv[])
{

char valid[] = "MGC";

struct                                     /*cardfile header: 16 bytes    */
{
  char    initials[3];
  unsigned int cardcnt;
  char fill1[6];
}
header;

FILE *fptr1, *fptr2;                       /* fptr1=cardfile; fptr2=outfile*/

struct                                     /* Struct for card header(index */
{
unsigned long data_displ;                  /* displacement of record data  */
char fill1[1];
char entry[47];                            /* Index record data            */
} index;

unsigned data_len = 0;                     /* Length (bytes) of card data  */
char  card_data[440];                      /* Buffer for card data         */

unsigned chcnt;                            /* char count for record        */
int   readcnt;
char  ch;                                  /* char buff for file read      */

unsigned nextptr;


clrscr();

printf("EXPCARD: Export Windows card file to ASCII file.\n\n");
printf("Beta version 0.1\n");
printf("Copyright 1991 MR. SOFTEE\n");


if (argc != 3)                              /* check number of arguments   */
  {
  printf("Command line syntax: EXPCARD cardfile exportfile\n");
                                            /* display error message       */
  exit();                                   /* get out                     */
  }
if((fptr1=fopen(argv[1], "r"))==NULL)       /* open file, set fptr1        */
  {
  printf("Unable to open file %s\n",argv[1]); /* error msg - file not found*/
  exit();
  }

if((fptr2=fopen(argv[2],"w"))==NULL)      /* open output file              */
  {
  printf("Unable to open %s\n", argv[2]); /* error msg - file not opened   */
  exit();
  }

fread(&header,sizeof(header),1,fptr1);

for(chcnt=0; chcnt<3;chcnt++)
 {
 if (header.initials[chcnt] != valid[chcnt])
   {
   printf("%s does not appear to be a cardfile.\n",argv[1]);
   printf("Continue anyway (Y/N)?");
   ch=getche();
   if (ch != 'Y' || ch != 'y')
    {
    exit();
    }
   }
 }
for(readcnt=1;readcnt<=header.cardcnt;++readcnt)
{
  fread(&index,sizeof(index),1,fptr1);       /*read index entries from cards*/
  nextptr=(sizeof(header) + (readcnt * sizeof(index))); /*point to next index*/
  fputs("\n\n",fptr2);
  fputs(index.entry,fptr2);                  /* write to output file        */

  if(fseek(fptr1,(index.data_displ+2),SEEK_SET)!=0)
  {
    printf("Bad pointer");
    exit();
  }

  fread(&data_len,2,1,fptr1);

  for (chcnt = 0; chcnt < data_len; chcnt++)
    card_data[chcnt]=getc(fptr1);

  fputs("\n",fptr2);
  fputs(card_data,fptr2);                   /* output to printer           */


  for (chcnt = 0; chcnt< sizeof(card_data); chcnt++)
    card_data[chcnt] = NULL;

  if (fseek(fptr1,nextptr,SEEK_SET)!=0)
  {
  printf("Bad pointer");
  exit();
  }
}
return 0;

}